Class: ActiveRecord::ConnectionAdapters::MysqlAdapter

### Home Classes Methods

### In Files

- lib/active_record/connection_adapters/mysql_adapter.rb

### Parent

ActiveRecord::ConnectionAdapters::AbstractAdapter

### Methods

- ::emulate_booleans
- ::new
- #active?
- #add_column
- #add_column_position!
- #case_sensitive_equality_operator
- #change_column_null
- #charset
- #collation
- #create_database
- #create_savepoint
- #current_database
- #disconnect!
- #drop_table
- #limited_update_conditions
- #primary_key
- #quote
- #quoted_columns_for_index
- #quoted_false
- #quoted_true
- #reconnect!
- #release_savepoint
- #rename_table
- #reset!
- #rollback_to_savepoint
- #select_rows
- #show_variable
- #translate_exception
- #type_to_sql

### Files

- README.rdoc

### Class/Module Index

Quicksearch

- ActiveRecord
- ActiveRecord::ActiveRecordError
- ActiveRecord::AdapterNotFound
- ActiveRecord::AdapterNotSpecified
- ActiveRecord::Aggregations
- ActiveRecord::Aggregations::ClassMethods
- ActiveRecord::AssociationPreload
- ActiveRecord::AssociationPreload::ClassMethods
- ActiveRecord::AssociationTypeMismatch
- ActiveRecord::Associations
- ActiveRecord::Associations::ClassMethods
- ActiveRecord::Associations::HasOneThroughAssociation
- ActiveRecord::Associations::ThroughAssociationScope
- ActiveRecord::AttributeAssignmentError
- ActiveRecord::AttributeMethods
- ActiveRecord::AttributeMethods::BeforeTypeCast
- ActiveRecord::AttributeMethods::ClassMethods
- ActiveRecord::AttributeMethods::Dirty
- ActiveRecord::AttributeMethods::PrimaryKey
- ActiveRecord::AttributeMethods::PrimaryKey::ClassMethods
- ActiveRecord::AttributeMethods::Query
- ActiveRecord::AttributeMethods::Read
- ActiveRecord::AttributeMethods::Read::ClassMethods
- ActiveRecord::AttributeMethods::TimeZoneConversion
- ActiveRecord::AttributeMethods::TimeZoneConversion::ClassMethods
- ActiveRecord::AttributeMethods::Write
- ActiveRecord::AttributeMethods::Write::ClassMethods
- ActiveRecord::AutosaveAssociation
- ActiveRecord::AutosaveAssociation::ClassMethods
- ActiveRecord::Base
- ActiveRecord::Calculations
- ActiveRecord::Callbacks
- ActiveRecord::Callbacks::ClassMethods
- ActiveRecord::ConfigurationError
- ActiveRecord::ConnectionAdapters
- ActiveRecord::ConnectionAdapters::AbstractAdapter
- ActiveRecord::ConnectionAdapters::Column
- ActiveRecord::ConnectionAdapters::Column::Format
- ActiveRecord::ConnectionAdapters::ConnectionHandler
- ActiveRecord::ConnectionAdapters::ConnectionManagement
- ActiveRecord::ConnectionAdapters::ConnectionPool
- ActiveRecord::ConnectionAdapters::DatabaseLimits
- ActiveRecord::ConnectionAdapters::DatabaseStatements
- ActiveRecord::ConnectionAdapters::MysqlAdapter
- ActiveRecord::ConnectionAdapters::PostgreSQLAdapter
- ActiveRecord::ConnectionAdapters::PostgreSQLColumn
- ActiveRecord::ConnectionAdapters::QueryCache
- ActiveRecord::ConnectionAdapters::Quoting
- ActiveRecord::ConnectionAdapters::SQLiteAdapter
- ActiveRecord::ConnectionAdapters::SQLiteAdapter::Version
- ActiveRecord::ConnectionAdapters::SchemaStatements
- ActiveRecord::ConnectionAdapters::Table
- ActiveRecord::ConnectionAdapters::TableDefinition
- ActiveRecord::ConnectionNotEstablished
- ActiveRecord::ConnectionTimeoutError
- ActiveRecord::CounterCache
- ActiveRecord::DangerousAttributeError
- ActiveRecord::DynamicFinderMatch
- ActiveRecord::DynamicScopeMatch
- ActiveRecord::FinderMethods
- ActiveRecord::Generators
- ActiveRecord::Generators::Migration
- ActiveRecord::Generators::MigrationGenerator
- ActiveRecord::Generators::ModelGenerator
- ActiveRecord::Generators::ObserverGenerator
- ActiveRecord::Generators::SessionMigrationGenerator
- ActiveRecord::InvalidForeignKey
- ActiveRecord::IrreversibleMigration
- ActiveRecord::Locking
- ActiveRecord::Locking::Optimistic
- ActiveRecord::Locking::Optimistic::ClassMethods
- ActiveRecord::Locking::Pessimistic
- ActiveRecord::LogSubscriber
- ActiveRecord::Migration
- ActiveRecord::MigrationProxy
- ActiveRecord::MultiparameterAssignmentErrors
- ActiveRecord::NamedScope
- ActiveRecord::NamedScope::ClassMethods
- ActiveRecord::NestedAttributes
- ActiveRecord::NestedAttributes::ClassMethods
- ActiveRecord::NestedAttributes::TooManyRecords
- ActiveRecord::Observer
- ActiveRecord::Persistence
- ActiveRecord::PredicateBuilder
- ActiveRecord::PreparedStatementInvalid
- ActiveRecord::QueryCache
- ActiveRecord::QueryCache::ClassMethods
- ActiveRecord::QueryMethods
- ActiveRecord::Railtie
- ActiveRecord::Railties
- ActiveRecord::Railties::ControllerRuntime
- ActiveRecord::Railties::ControllerRuntime::ClassMethods
- ActiveRecord::ReadOnlyRecord
- ActiveRecord::RecordInvalid
- ActiveRecord::RecordNotFound
- ActiveRecord::RecordNotSaved
- ActiveRecord::RecordNotUnique
- ActiveRecord::Reflection
- ActiveRecord::Reflection::ClassMethods
- ActiveRecord::Reflection::MacroReflection
- ActiveRecord::Relation
- ActiveRecord::Rollback
- ActiveRecord::Schema
- ActiveRecord::Serialization
- ActiveRecord::SerializationTypeMismatch
- ActiveRecord::SessionStore
- ActiveRecord::SessionStore::Session
- ActiveRecord::SessionStore::SqlBypass
- ActiveRecord::SpawnMethods
- ActiveRecord::StaleObjectError
- ActiveRecord::StatementInvalid
- ActiveRecord::TestFixtures
- ActiveRecord::TestFixtures::ClassMethods
- ActiveRecord::ThrowResult
- ActiveRecord::Timestamp
- ActiveRecord::Transactions
- ActiveRecord::Transactions::ClassMethods
- ActiveRecord::UnknownAttributeError
- ActiveRecord::Validations
- ActiveRecord::Validations::AssociatedValidator
- ActiveRecord::Validations::ClassMethods
- ActiveRecord::Validations::UniquenessValidator
- ActiveRecord::WrappedDatabaseException
- <
- Fixtures
- FixturesFileNotFound

No matching classes.

# ActiveRecord::ConnectionAdapters::MysqlAdapter

The MySQL adapter will work with both Ruby/MySQL, which is a Ruby-based MySQL adapter that comes bundled with Active Record, and with the faster C-based MySQL/Ruby adapter (available both as a gem and from www.tmtm.org/en/mysql/ruby/).

Options:

- `:host` - Defaults to "localhost".

- `:port` - Defaults to 3306.

- `:socket` - Defaults to "/tmp/mysql.sock".

- `:username` - Defaults to "root"

- `:password` - Defaults to nothing.

- `:database` - The name of the database. No default, must be provided.

- `:encoding` - (Optional) Sets the client encoding by executing "SET NAMES <encoding>" after connection.

- `:reconnect` - Defaults to false (See MySQL documentation: dev.mysql.com/doc/refman/5.0/en/auto-reconnect.html).

- `:sslca` - Necessary to use MySQL with an SSL connection.

- `:sslkey` - Necessary to use MySQL with an SSL connection.

- `:sslcert` - Necessary to use MySQL with an SSL connection.

- `:sslcapath` - Necessary to use MySQL with an SSL connection.

- `:sslcipher` - Necessary to use MySQL with an SSL connection.

### Constants

ADAPTER_NAME
LOST_CONNECTION_ERROR_MESSAGES
NATIVE_DATABASE_TYPES
QUOTED_FALSE

### Public Class Methods

emulate_booleans click to toggle source

By default, the MysqlAdapter will consider all columns of type `tinyint(1)` as boolean. If you wish to disable this emulation (which was the default behavior in versions 0.13.1 and earlier) you can add the following line to your application.rb file:

    ActiveRecord::ConnectionAdapters::MysqlAdapter.emulate_booleans = false

    # File lib/active_record/connection_adapters/mysql_adapter.rb, line 132
    cattr_accessor :emulate_booleans

new(connection, logger, connection_options, config) click to toggle source

    # File lib/active_record/connection_adapters/mysql_adapter.rb, line 160
    def initialize(connection, logger, connection_options, config)
      super(connection, logger)
      @connection_options, @config = connection_options, config
      @quoted_column_names, @quoted_table_names = {}, {}
      connect
    end

### Public Instance Methods

active?() click to toggle source

CONNECTION MANAGEMENT ====================================

    # File lib/active_record/connection_adapters/mysql_adapter.rb, line 236
    def active?
      if @connection.respond_to?(:stat)
        @connection.stat
      else
        @connection.query 'select 1'
      end

      # mysql-ruby doesn't raise an exception when stat fails.
      if @connection.respond_to?(:errno)
        @connection.errno.zero?
      else
        true
      end
    rescue Mysql::Error
      false
    end

add_column(table_name, column_name, type, options = {}) click to toggle source

    # File lib/active_record/connection_adapters/mysql_adapter.rb, line 452
    def add_column(table_name, column_name, type, options = {})
      add_column_sql = "ALTER TABLE #{quote_table_name(table_name)} ADD #{quote_column_name(column_name)} #{type_to_sql(type, options[:limit], options[:precision], options[:scale])}"
      add_column_options!(add_column_sql, options)
      add_column_position!(add_column_sql, options)
      execute(add_column_sql)
    end

add_column_position!(sql, options) click to toggle source

    # File lib/active_record/connection_adapters/mysql_adapter.rb, line 519
    def add_column_position!(sql, options)
      if options[:first]
        sql << " FIRST"
      elsif options[:after]
        sql << " AFTER #{quote_column_name(options[:after])}"
      end
    end

case_sensitive_equality_operator() click to toggle source

    # File lib/active_record/connection_adapters/mysql_adapter.rb, line 550
    def case_sensitive_equality_operator
      "= BINARY"
    end

change_column_null(table_name, column_name, null, default = nil) click to toggle source

    # File lib/active_record/connection_adapters/mysql_adapter.rb, line 464
    def change_column_null(table_name, column_name, null, default = nil)
      column = column_for(table_name, column_name)

      unless null || default.nil?
        execute("UPDATE #{quote_table_name(table_name)} SET #{quote_column_name(column_name)}=#{quote(default)} WHERE #{quote_column_name(column_name)} IS NULL")
      end

      change_column table_name, column_name, column.sql_type, :null => null
    end

charset() click to toggle source

Returns the database character set.

    # File lib/active_record/connection_adapters/mysql_adapter.rb, line 396
    def charset
      show_variable 'character_set_database'
    end

collation() click to toggle source

Returns the database collation strategy.

    # File lib/active_record/connection_adapters/mysql_adapter.rb, line 401
    def collation
      show_variable 'collation_database'
    end

create_database(name, options = {}) click to toggle source

Create a new MySQL database with optional `:charset` and `:collation`. Charset defaults to utf8.

Example:

    create_database 'charset_test', :charset => 'latin1', :collation => 'latin1_bin'
    create_database 'matt_development'
    create_database 'matt_development', :charset => :big5

    # File lib/active_record/connection_adapters/mysql_adapter.rb, line 379
    def create_database(name, options = {})
      if options[:collation]
        execute "CREATE DATABASE `#{name}` DEFAULT CHARACTER SET `#{options[:charset] || 'utf8'}` COLLATE `#{options[:collation]}`"
      else
        execute "CREATE DATABASE `#{name}` DEFAULT CHARACTER SET `#{options[:charset] || 'utf8'}`"
      end
    end

create_savepoint() click to toggle source

    # File lib/active_record/connection_adapters/mysql_adapter.rb, line 328
    def create_savepoint
      execute("SAVEPOINT #{current_savepoint_name}")
    end

current_database() click to toggle source

    # File lib/active_record/connection_adapters/mysql_adapter.rb, line 391
    def current_database
      select_value 'SELECT DATABASE() as db'
    end

disconnect!() click to toggle source

    # File lib/active_record/connection_adapters/mysql_adapter.rb, line 258
    def disconnect!
      @connection.close rescue nil
    end

drop_table(table_name, options = {}) click to toggle source

    # File lib/active_record/connection_adapters/mysql_adapter.rb, line 413
    def drop_table(table_name, options = {})
      super(table_name, options)
    end

limited_update_conditions(where_sql, quoted_table_name, quoted_primary_key) click to toggle source

    # File lib/active_record/connection_adapters/mysql_adapter.rb, line 554
    def limited_update_conditions(where_sql, quoted_table_name, quoted_primary_key)
      where_sql
    end

primary_key(table) click to toggle source

Returns just a table’s primary key

    # File lib/active_record/connection_adapters/mysql_adapter.rb, line 545
    def primary_key(table)
      pk_and_sequence = pk_and_sequence_for(table)
      pk_and_sequence && pk_and_sequence.first
    end

quote(value, column = nil) click to toggle source

QUOTING ==================================================

    # File lib/active_record/connection_adapters/mysql_adapter.rb, line 190
    def quote(value, column = nil)
      if value.kind_of?(String) && column && column.type == :binary && column.class.respond_to?(:string_to_binary)
        s = column.class.string_to_binary(value).unpack("H*")[0]
        "x'#{s}'"
      elsif value.kind_of?(BigDecimal)
        value.to_s("F")
      else
        super
      end
    end

quoted_false() click to toggle source

    # File lib/active_record/connection_adapters/mysql_adapter.rb, line 217
    def quoted_false
      QUOTED_FALSE
    end

quoted_true() click to toggle source

    # File lib/active_record/connection_adapters/mysql_adapter.rb, line 213
    def quoted_true
      QUOTED_TRUE
    end

reconnect!() click to toggle source

    # File lib/active_record/connection_adapters/mysql_adapter.rb, line 253
    def reconnect!
      disconnect!
      connect
    end

release_savepoint() click to toggle source

    # File lib/active_record/connection_adapters/mysql_adapter.rb, line 336
    def release_savepoint
      execute("RELEASE SAVEPOINT #{current_savepoint_name}")
    end

rename_table(table_name, new_name) click to toggle source

    # File lib/active_record/connection_adapters/mysql_adapter.rb, line 448
    def rename_table(table_name, new_name)
      execute "RENAME TABLE #{quote_table_name(table_name)} TO #{quote_table_name(new_name)}"
    end

reset!() click to toggle source

    # File lib/active_record/connection_adapters/mysql_adapter.rb, line 262
    def reset!
      if @connection.respond_to?(:change_user)
        # See http://bugs.mysql.com/bug.php?id=33540 -- the workaround way to
        # reset the connection is to change the user to the same user.
        @connection.change_user(@config[:username], @config[:password], @config[:database])
        configure_connection
      end
    end

rollback_to_savepoint() click to toggle source

    # File lib/active_record/connection_adapters/mysql_adapter.rb, line 332
    def rollback_to_savepoint
      execute("ROLLBACK TO SAVEPOINT #{current_savepoint_name}")
    end

select_rows(sql, name = nil) click to toggle source

DATABASE STATEMENTS ======================================

    # File lib/active_record/connection_adapters/mysql_adapter.rb, line 273
    def select_rows(sql, name = nil)
      @connection.query_with_result = true
      result = execute(sql, name)
      rows = []
      result.each { |row| rows << row }
      result.free
      @connection.more_results && @connection.next_result    # invoking stored procedures with CLIENT_MULTI_RESULTS requires this to tidy up else connection will be dropped
      rows
    end

show_variable(name) click to toggle source

SHOW VARIABLES LIKE ‘name’

    # File lib/active_record/connection_adapters/mysql_adapter.rb, line 528
    def show_variable(name)
      variables = select_all("SHOW VARIABLES LIKE '#{name}'")
      variables.first['Value'] unless variables.empty?
    end

type_to_sql(type, limit = nil, precision = nil, scale = nil) click to toggle source

Maps logical Rails types to MySQL-specific data types.

    # File lib/active_record/connection_adapters/mysql_adapter.rb, line 506
    def type_to_sql(type, limit = nil, precision = nil, scale = nil)
      return super unless type.to_s == 'integer'

      case limit
      when 1; 'tinyint'
      when 2; 'smallint'
      when 3; 'mediumint'
      when nil, 4, 11; 'int(11)'  # compatibility with MySQL default
      when 5..8; 'bigint'
      else raise(ActiveRecordError, "No integer type has byte size #{limit}")
      end
    end

### Protected Instance Methods

quoted_columns_for_index(column_names, options = {}) click to toggle source

    # File lib/active_record/connection_adapters/mysql_adapter.rb, line 559
    def quoted_columns_for_index(column_names, options = {})
      length = options[:length] if options.is_a?(Hash)

      quoted_column_names = case length
      when Hash
        column_names.map {|name| length[name] ? "#{quote_column_name(name)}(#{length[name]})" : quote_column_name(name) }
      when Fixnum
        column_names.map {|name| "#{quote_column_name(name)}(#{length})"}
      else
        column_names.map {|name| quote_column_name(name) }
      end
    end

translate_exception(exception, message) click to toggle source

    # File lib/active_record/connection_adapters/mysql_adapter.rb, line 572
    def translate_exception(exception, message)
      return super unless exception.respond_to?(:errno)

      case exception.errno
      when 1062
        RecordNotUnique.new(message, exception)
      when 1452
        InvalidForeignKey.new(message, exception)
      else
        super
      end
    end

[Validate]

Generated with the Darkfish Rdoc Generator 2.